
local RDPS_TOOLTIP_DISPLAY = "|cffeda55fClick|r to reset Raid DPS"

--[[local L = GetLocale()
if L == "frFR" then
	RDPS_TOOLTIP_DISPLAY = "|cffeda55fClick|r to reset Raid DPS"
end]]

local RDPS = CreateFrame("Frame", "StatBlock_RaidDPS")
local lbl = "RDPS"
RDPS.obj = LibStub("LibDataBroker-1.1"):NewDataObject(lbl, {type = "data source", value = "0.0", suffix = lbl, text = "0.0"..lbl})

local GetTime = GetTime
local band = bit.band
local format = string.format

local raidDamage = 0
local combatStartTime = 0

RDPS:RegisterEvent("PLAYER_REGEN_DISABLED")
RDPS:RegisterEvent("PLAYER_REGEN_ENABLED")
RDPS:SetScript("OnEvent", function(_, event, ...)
	RDPS[event](RDPS, ...)
end)

local txt = "%.1f"
function RDPS:Update()
	local dmg = format(txt, raidDamage / (GetTime() - combatStartTime))
	self.obj.text = dmg..lbl
	self.obj.value = dmg
end

local events = {
	SWING_DAMAGE = true,
	RANGE_DAMAGE = true,
	SPELL_DAMAGE = true,
	SPELL_PERIODIC_DAMAGE = true,
	DAMAGE_SHIELD = true,
	DAMAGE_SPLIT = true,
}
local srcRaidFilter = bit.bor(COMBATLOG_OBJECT_AFFILIATION_RAID,
	COMBATLOG_OBJECT_AFFILIATION_PARTY, COMBATLOG_OBJECT_AFFILIATION_MINE
)
function RDPS:COMBAT_LOG_EVENT_UNFILTERED(_, eventType, _, _, _, sourceFlags, _, _, _, _, _, spellID, _, _, damage)
	if not events[eventType] then return end
	if band(sourceFlags, srcRaidFilter) == 0 then return end

	if eventType == "SWING_DAMAGE" then
		damage = spellID
	end

	raidDamage = raidDamage + damage
	self:Update()
end

function RDPS:PLAYER_REGEN_DISABLED()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	combatStartTime = GetTime()
	raidDamage = 0
end

function RDPS:PLAYER_REGEN_ENABLED()
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:Update()
end

function RDPS.obj.OnTooltipShow(tooltip)
	if tooltip and tooltip.AddLine then
		tooltip:AddLine(RDPS_TOOLTIP_DISPLAY)
	end
end

function RDPS.obj.OnClick()
	combatStartTime = GetTime()
	raidDamage = 0
	RDPS.obj.text = "0.0"..lbl
	RDPS.obj.value = "0.0"
end

